Index: trunk/src/world_entities/projectiles/projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/projectile.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/projectile.cc	(revision 9869)
@@ -22,8 +22,9 @@
 #include "world_entities/weapons/weapon.h"
 #include "model.h"
-#include "util/loading/resource_manager.h"
+#include "sound/resource_sound_buffer.h"
 
 #include "debug.h"
 
+ObjectListDefinition(Projectile);
 
 /**
@@ -32,5 +33,5 @@
 Projectile::Projectile () : WorldEntity()
 {
-  this->setClassID(CL_PROJECTILE, "Projectile");
+  this->registerObject(this, Projectile::_objectList);
 
   this->lifeCycle = 0.0;
@@ -43,7 +44,4 @@
   this->setDamage(1.0f); // default damage of a projectile set to 100.0 damage points
 
-  this->explosionBuffer = NULL;
-  this->engineBuffer = NULL;
-
   //this->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
 }
@@ -55,8 +53,4 @@
 Projectile::~Projectile ()
 {
-  if (this->explosionBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->explosionBuffer);
-  if (this->engineBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->engineBuffer);
   /*
      do not delete the test projectModel, since it is pnode
@@ -69,21 +63,8 @@
 void Projectile::loadExplosionSound(const std::string& explosionSound)
 {
-  if (this->explosionBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->explosionBuffer);
-
-  else if (!explosionSound.empty())
-  {
-    this->explosionBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load(explosionSound, WAV);
-    if (this->explosionBuffer != NULL)
-    {
-      PRINTF(4)("Loaded sound %s to Pickup: %s.\n", explosionSound.c_str(), this->getCName());
-    }
-    else
-    {
-      PRINTF(2)("Failed to load sound %s to explosion %s.\n.", explosionSound.c_str(), this->getCName());
-    }
-  }
+  if (!explosionSound.empty())
+    this->explosionBuffer = OrxSound::ResourceSoundBuffer(explosionSound);
   else
-    this->explosionBuffer = NULL;
+    this->explosionBuffer = OrxSound::SoundBuffer();
 }
 
@@ -91,21 +72,8 @@
 void Projectile::loadEngineSound(const std::string& engineSound)
 {
-  if (this->engineBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->engineBuffer);
-
-  else if (!engineSound.empty())
-  {
-    this->engineBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load(engineSound, WAV);
-    if (this->engineBuffer != NULL)
-    {
-      PRINTF(4)("Loaded sound %s to Pickup: %s.\n", engineSound.c_str(), this->getCName());
-    }
-    else
-    {
-      PRINTF(2)("Failed to load sound %s to engine %s.\n.", engineSound.c_str(), this->getCName());
-    }
-  }
+  if (!engineSound.empty())
+    this->engineBuffer = OrxSound::ResourceSoundBuffer(engineSound);
   else
-    this->engineBuffer = NULL;
+    this->engineBuffer = OrxSound::SoundBuffer();
 }
 
@@ -139,5 +107,5 @@
   //Vector offsetVel =
   this->velocity = velocity;
- // offsetVel.normalize();
+  // offsetVel.normalize();
   //this->velocity += (offsetVel * 50.0);
 }
@@ -148,5 +116,5 @@
 {
   if (this->target == NULL)
-    this->target = new PNode(target, PNODE_PARENT_MODE_DEFAULT | PNODE_REPARENT_ON_PARENTS_REMOVE);
+    this->target = new PNode(target, PNODE_REPARENT_ON_PARENTS_REMOVE | PNODE_REPARENT_TO_NULL | PNODE_PROHIBIT_DELETE_WITH_PARENT);
   else
     this->target->setParent(target);
@@ -173,5 +141,5 @@
 void Projectile::destroy (WorldEntity* killer)
 {
-  if (this->explosionBuffer != NULL)
+  if (this->explosionBuffer.loaded())
     this->soundSource.play(this->explosionBuffer);
 }
Index: trunk/src/world_entities/projectiles/projectile.h
===================================================================
--- trunk/src/world_entities/projectiles/projectile.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/projectile.h	(revision 9869)
@@ -11,5 +11,5 @@
 
 #include "world_entity.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "sound_source.h"
@@ -18,4 +18,5 @@
 class Projectile : public WorldEntity
 {
+  ObjectListDeclaration(Projectile);
   public:
     Projectile ();
@@ -66,6 +67,6 @@
     OrxSound::SoundSource  soundSource;
   private:
-    OrxSound::SoundBuffer* explosionBuffer;
-    OrxSound::SoundBuffer* engineBuffer;
+    OrxSound::SoundBuffer  explosionBuffer;
+    OrxSound::SoundBuffer  engineBuffer;
 };
 
Index: trunk/src/world_entities/projectiles/rail_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 9869)
@@ -19,9 +19,8 @@
 
 #include "state.h"
-#include "class_list.h"
 #include "model.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include <cassert>
@@ -29,6 +28,7 @@
 
 
-
-CREATE_FAST_FACTORY_STATIC(RailProjectile, CL_RAIL_PROJECTILE);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(RailProjectile, CL_RAIL_PROJECTILE);
+CREATE_FAST_FACTORY_STATIC(RailProjectile);
 
 /**
@@ -37,7 +37,7 @@
 RailProjectile::RailProjectile () : Projectile()
 {
-  this->setClassID(CL_RAIL_PROJECTILE, "RailProjectile");
+  this->registerObject(this, RailProjectile::_objectList);
 
-  this->loadModel("models/projectiles/laser_projectile.obj", 100);
+  this->loadModel("models/projectiles/laser.obj", 1);
 
   this->setMinEnergy(10);
@@ -61,5 +61,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (RailProjectile::explosionParticles != NULL && ClassList::getList(CL_RAIL_PROJECTILE)->size() <= 1)
+  if (RailProjectile::explosionParticles != NULL && RailProjectile::objectList().size() <= 1)
   {
     //if (ClassList::exists(RailProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/projectiles/rail_projectile.h
===================================================================
--- trunk/src/world_entities/projectiles/rail_projectile.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/rail_projectile.h	(revision 9869)
@@ -17,4 +17,5 @@
 class RailProjectile : public Projectile
 {
+  ObjectListDeclaration(RailProjectile);
   public:
     RailProjectile ();
Index: trunk/src/world_entities/projectiles/rocket.cc
===================================================================
--- trunk/src/world_entities/projectiles/rocket.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/rocket.cc	(revision 9869)
@@ -19,12 +19,13 @@
 
 #include "state.h"
-#include "class_list.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Rocket, CL_ROCKET);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Rocket, CL_ROCKET);
+CREATE_FAST_FACTORY_STATIC(Rocket);
 
 /**
@@ -33,5 +34,5 @@
 Rocket::Rocket () : Projectile()
 {
-  this->setClassID(CL_ROCKET, "Rocket");
+  this->registerObject(this, Rocket::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
@@ -55,5 +56,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Rocket::trailParticles != NULL && ClassList::getList(CL_ROCKET)->size() <= 1)
+  if (Rocket::trailParticles != NULL && Rocket::objectList().size() <= 1)
   {
 /*    if (ClassList::exists(Rocket::trailParticles, CL_PARTICLE_SYSTEM))
@@ -61,5 +62,5 @@
     Rocket::trailParticles = NULL;
   }
-  if (Rocket::explosionParticles != NULL && ClassList::getList(CL_ROCKET)->size() <= 1)
+  if (Rocket::explosionParticles != NULL && Rocket::objectList().size() <= 1)
   {
 /*    if (ClassList::exists(Rocket::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/projectiles/rocket.h
===================================================================
--- trunk/src/world_entities/projectiles/rocket.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/rocket.h	(revision 9869)
@@ -9,6 +9,4 @@
 #include "projectile.h"
 
-class Vector;
-class Weapon;
 class SpriteParticles;
 class ParticleEmitter;
@@ -17,29 +15,31 @@
 class Rocket : public Projectile
 {
-  public:
-    Rocket ();
-    virtual ~Rocket ();
+  ObjectListDeclaration(Rocket);
+
+public:
+  Rocket ();
+  virtual ~Rocket ();
 
 
-    virtual void activate();
-    virtual void deactivate();
+  virtual void activate();
+  virtual void deactivate();
 
-    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
 
-    virtual void destroy (WorldEntity* killer);
+  virtual void destroy (WorldEntity* killer);
 
-    virtual void tick (float time);
-    virtual void draw () const;
+  virtual void tick (float time);
+  virtual void draw () const;
 
 
-  private:
-    static FastFactory*               fastFactory;
-    static SpriteParticles*           trailParticles;
-    static SpriteParticles*           explosionParticles;
+private:
+  static FastFactory*               fastFactory;
+  static SpriteParticles*           trailParticles;
+  static SpriteParticles*           explosionParticles;
 
-    ParticleEmitter*                  emitter;
+  ParticleEmitter*                  emitter;
 
 
-    WorldEntity* hitEntity; // FIXME TEMPORARY
+  WorldEntity* hitEntity; // FIXME TEMPORARY
 
 };
Index: trunk/src/world_entities/projectiles/test_bullet.cc
===================================================================
--- trunk/src/world_entities/projectiles/test_bullet.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/test_bullet.cc	(revision 9869)
@@ -19,11 +19,12 @@
 
 #include "state.h"
-#include "class_list.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(TestBullet, CL_TEST_BULLET);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(TestBullet, CL_TEST_BULLET);
+CREATE_FAST_FACTORY_STATIC(TestBullet);
 
 /**
@@ -32,5 +33,5 @@
 TestBullet::TestBullet () : Projectile()
 {
-  this->setClassID(CL_TEST_BULLET, "TestBullet");
+  this->registerObject(this, TestBullet::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
@@ -54,13 +55,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (TestBullet::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
+  if (TestBullet::trailParticles != NULL && TestBullet::objectList().size() <= 1)
   {
-    if (ClassList::exists(TestBullet::trailParticles, CL_PARTICLE_SYSTEM))
+    if (ParticleSystem::objectList().exists(TestBullet::trailParticles))
       delete TestBullet::trailParticles;
     TestBullet::trailParticles = NULL;
   }
-  if (TestBullet::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
+  if (TestBullet::explosionParticles != NULL && TestBullet::objectList().size() <= 1)
   {
-    if (ClassList::exists(TestBullet::explosionParticles, CL_PARTICLE_SYSTEM))
+    if (ParticleSystem::objectList().exists(TestBullet::explosionParticles))
       delete TestBullet::explosionParticles;
     TestBullet::explosionParticles = NULL;
Index: trunk/src/world_entities/projectiles/test_bullet.h
===================================================================
--- trunk/src/world_entities/projectiles/test_bullet.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/test_bullet.h	(revision 9869)
@@ -17,4 +17,6 @@
 class TestBullet : public Projectile
 {
+  ObjectListDeclaration(TestBullet);
+
   public:
     TestBullet ();
Index: trunk/src/world_entities/recorder.cc
===================================================================
--- trunk/src/world_entities/recorder.cc	(revision 9656)
+++ trunk/src/world_entities/recorder.cc	(revision 9869)
@@ -18,15 +18,15 @@
 #include "util/loading/load_param.h"
 #include "util/loading/factory.h"
-#include "util/loading/resource_manager.h"
 #include "state.h"
-
-
-
-CREATE_FACTORY(Recorder, CL_RECORDER);
+#include "debug.h"
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Recorder, CL_RECORDER);
+CREATE_FACTORY(Recorder);
 
 
 Recorder::Recorder (const TiXmlElement* root)
 {
-  this->setClassID(CL_RECORDER, "Recorder");
+  this->registerObject(this, Recorder::_objectList);
 
   // initialize libavcodec, and register all codecs and formats
Index: trunk/src/world_entities/recorder.h
===================================================================
--- trunk/src/world_entities/recorder.h	(revision 9656)
+++ trunk/src/world_entities/recorder.h	(revision 9869)
@@ -20,4 +20,5 @@
 class Recorder : public WorldEntity
 {
+  ObjectListDeclaration(Recorder);
   public:
     Recorder (const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/satellite.cc
===================================================================
--- trunk/src/world_entities/satellite.cc	(revision 9656)
+++ trunk/src/world_entities/satellite.cc	(revision 9869)
@@ -21,8 +21,9 @@
 
 #include "objModel.h"
-#include "vector.h"
 
 
 
+
+ObjectListDefinition(Satellite);
 
 /**
@@ -31,5 +32,5 @@
 Satellite::Satellite (Vector axis, float speed)
 {
-  this->setClassID(CL_SATELLITE, "Satellite");
+  this->registerObject(this, Satellite::_objectList);
 
   this->loadModel("cube");
Index: trunk/src/world_entities/satellite.h
===================================================================
--- trunk/src/world_entities/satellite.h	(revision 9656)
+++ trunk/src/world_entities/satellite.h	(revision 9869)
@@ -9,6 +9,4 @@
 #include "world_entity.h"
 #include "comincl.h"
-#include "util/loading/resource_manager.h"
-
 
 class CharacterAttributes;
@@ -19,5 +17,5 @@
 class Satellite : public WorldEntity
 {
-  friend class World;
+  ObjectListDeclaration(Satellite);
 
  public:
Index: trunk/src/world_entities/script_trigger.cc
===================================================================
--- trunk/src/world_entities/script_trigger.cc	(revision 9656)
+++ trunk/src/world_entities/script_trigger.cc	(revision 9869)
@@ -16,28 +16,28 @@
 
 #include "script_trigger.h"
-#include "class_list.h"
 #include "script.h"
 
 #include "state.h"
-
-
-CREATE_SCRIPTABLE_CLASS(ScriptTrigger, CL_SCRIPT_TRIGGER,
+#include "debug.h"
+ObjectListDefinition(ScriptTrigger);
+
+CREATE_SCRIPTABLE_CLASS(ScriptTrigger,
             // Coordinates
-             addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-             ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-             ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-             ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+			addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+			    ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+			    ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+			    ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
             //Properties
-             ->addMethod("setName", ExecutorLua1<BaseObject, const std::string&>(&BaseObject::setName))
-             ->addMethod("setTarget", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setTarget))
-             ->addMethod("setTriggerParent", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setTriggerParent))
-             ->addMethod("setTriggerRemains", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setTriggerRemains))
-             ->addMethod("setActiveOnCreation", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setActiveOnCreation))
-             ->addMethod("setInvert", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setInvert))
-             ->addMethod("setRadius", ExecutorLua1<ScriptTrigger, float>(&ScriptTrigger::setRadius))
-             ->addMethod("setScript", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setScript))
-             ->addMethod("setFunction", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setFunction))
-             ->addMethod("setDebugDraw", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setDebugDraw))
-             ->addMethod("setAddToScript", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setAddToScript))
+			    ->addMethod("setName", Executor1<BaseObject, lua_State*, const std::string&>(&BaseObject::setName))
+			    ->addMethod("setTarget", Executor1<ScriptTrigger, lua_State*, const std::string&>(&ScriptTrigger::setTarget))
+			    ->addMethod("setTriggerParent", Executor1<ScriptTrigger, lua_State*, const std::string&>(&ScriptTrigger::setTriggerParent))
+			    ->addMethod("setTriggerRemains", Executor1<ScriptTrigger, lua_State*, bool>(&ScriptTrigger::setTriggerRemains))
+			    ->addMethod("setActiveOnCreation", Executor1<ScriptTrigger, lua_State*, bool>(&ScriptTrigger::setActiveOnCreation))
+			    ->addMethod("setInvert", Executor1<ScriptTrigger, lua_State*, bool>(&ScriptTrigger::setInvert))
+			    ->addMethod("setRadius", Executor1<ScriptTrigger, lua_State*, float>(&ScriptTrigger::setRadius))
+			    ->addMethod("setScript", Executor1<ScriptTrigger, lua_State*, const std::string&>(&ScriptTrigger::setScript))
+			    ->addMethod("setFunction", Executor1<ScriptTrigger, lua_State*, const std::string&>(&ScriptTrigger::setFunction))
+			    ->addMethod("setDebugDraw", Executor1<ScriptTrigger, lua_State*, bool>(&ScriptTrigger::setDebugDraw))
+			    ->addMethod("setAddToScript", Executor1<ScriptTrigger, lua_State*, bool>(&ScriptTrigger::setAddToScript))
              );
 
@@ -49,6 +49,6 @@
  */
 ScriptTrigger::ScriptTrigger(const TiXmlElement* root)
-{ 
-  this->setClassID(CL_SCRIPT_TRIGGER, "ScriptTrigger");
+{
+  this->registerObject(this, ScriptTrigger::_objectList);
   this->toList(OM_COMMON);
 
@@ -139,9 +139,9 @@
 void ScriptTrigger::setTarget(const std::string& target)
 {
-  BaseObject* targetEntity = ClassList::getObject(target, CL_WORLD_ENTITY);
-
+
+  WorldEntity* targetEntity = WorldEntity::objectList().getObject(target);
   if (targetEntity != NULL)
   {
-    this->setTarget(dynamic_cast<WorldEntity*>(targetEntity));
+    this->setTarget(targetEntity);
   }
   else
@@ -157,9 +157,9 @@
 void ScriptTrigger::setTriggerParent(const std::string& parent)
 {
-  BaseObject* parentEntity = ClassList::getObject(parent, CL_WORLD_ENTITY);
+  WorldEntity* parentEntity = WorldEntity::objectList().getObject(parent);
 
   if (parentEntity != NULL)
   {
-    this->setParent(dynamic_cast<WorldEntity*>(parentEntity));
+    this->setParent(parentEntity);
     this->setParentMode(PNODE_MOVEMENT);
   }
Index: trunk/src/world_entities/script_trigger.h
===================================================================
--- trunk/src/world_entities/script_trigger.h	(revision 9656)
+++ trunk/src/world_entities/script_trigger.h	(revision 9869)
@@ -18,4 +18,5 @@
 class ScriptTrigger : public WorldEntity
 {
+  ObjectListDeclaration(ScriptTrigger);
   public:
     ScriptTrigger(const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/skybox.cc
===================================================================
--- trunk/src/world_entities/skybox.cc	(revision 9656)
+++ trunk/src/world_entities/skybox.cc	(revision 9869)
@@ -27,10 +27,11 @@
 #include "network_game_manager.h"
 #include "converter.h"
-#include "util/loading/resource_manager.h"
-
-
-
-
-CREATE_FACTORY(SkyBox, CL_SKYBOX);
+#include "resource_texture.h"
+
+#include "debug.h"
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(SkyBox, CL_SKYBOX);
+CREATE_FACTORY(SkyBox);
 
 /**
@@ -72,5 +73,5 @@
 void SkyBox::preInit()
 {
-  this->setClassID(CL_SKYBOX, "SkyBox");
+  this->registerObject(this, SkyBox::_objectList);
   this->toList(OM_BACKGROUND);
   this->toReflectionList();
@@ -112,6 +113,4 @@
     if (this->material[i])
       delete this->material[i];
-    if (this->cubeTexture[i])
-      ResourceManager::getInstance()->unload(this->cubeTexture[i]);
   }
 }
@@ -174,12 +173,12 @@
                                   const std::string& posZ, const std::string& posX, const std::string& negX)
 {
-  this->cubeTexture[0] = (Texture*)ResourceManager::getInstance()->load(negX, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT);
-  this->cubeTexture[1] = (Texture*)ResourceManager::getInstance()->load(posX, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT);
-
-  this->cubeTexture[2] = (Texture*)ResourceManager::getInstance()->load(negY, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT);
-  this->cubeTexture[3] = (Texture*)ResourceManager::getInstance()->load(posY, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT);
-
-  this->cubeTexture[4] = (Texture*)ResourceManager::getInstance()->load(negZ, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT);
-  this->cubeTexture[5] = (Texture*)ResourceManager::getInstance()->load(posZ, RP_LEVEL, IMAGE, GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT);
+  this->cubeTexture[0] = ResourceTexture(negX, GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT);
+  this->cubeTexture[1] = ResourceTexture(posX, GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT);
+
+  this->cubeTexture[2] = ResourceTexture(negY, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT);
+  this->cubeTexture[3] = ResourceTexture(posY, GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT);
+
+  this->cubeTexture[4] = ResourceTexture(negZ, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT);
+  this->cubeTexture[5] = ResourceTexture(posZ, GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT);
 }
 
Index: trunk/src/world_entities/skybox.h
===================================================================
--- trunk/src/world_entities/skybox.h	(revision 9656)
+++ trunk/src/world_entities/skybox.h	(revision 9869)
@@ -27,5 +27,6 @@
 class SkyBox : public WorldEntity
 {
- public:
+  ObjectListDeclaration(SkyBox);
+public:
   SkyBox(const std::string& fileName = "");
   SkyBox(const TiXmlElement* root);
@@ -64,5 +65,5 @@
 
   Material*       material[6];     //!< Materials for the SkyBox. sorted by number (0-5) top, bottom, left, right, front, back
-  Texture*        cubeTexture[6];  //!< Textures for the CubeMap.
+  Texture         cubeTexture[6];  //!< Textures for the CubeMap.
 
   float           size;            //!< Size of the SkyBox. This should match the frustum maximum range.
Index: trunk/src/world_entities/skydome.cc
===================================================================
--- trunk/src/world_entities/skydome.cc	(revision 9656)
+++ trunk/src/world_entities/skydome.cc	(revision 9869)
@@ -23,5 +23,6 @@
 #include "network_game_manager.h"
 #include "converter.h"
-#include "util/loading/resource_manager.h"
+
+#include "debug.h"
 
 #define DTOR (PI/180.0f)
@@ -30,4 +31,5 @@
 
 
+ObjectListDefinition(Skydome);
 
 /**
@@ -42,7 +44,7 @@
 void Skydome::init()
 {
-  PRINTF(0)("Skydome init\n");
-
-  this->setClassID(CL_SKYDOME, "Skydome");
+  PRINTF(4)("Skydome init\n");
+
+  this->registerObject(this, Skydome::_objectList);
   this->toList(OM_BACKGROUND);
   this->toReflectionList();
@@ -61,5 +63,5 @@
 Skydome::~Skydome()
 {
-  PRINTF(0)("Deleting Skydome\n");
+  PRINTF(4)("Deleting Skydome\n");
 
   if (glIsTexture(texture))
@@ -119,5 +121,5 @@
   glEnd();
 
-  WorldEntity::draw(); 
+  WorldEntity::draw();
 
   glPopMatrix();
Index: trunk/src/world_entities/skydome.h
===================================================================
--- trunk/src/world_entities/skydome.h	(revision 9656)
+++ trunk/src/world_entities/skydome.h	(revision 9869)
@@ -21,4 +21,5 @@
 class Skydome : public WorldEntity
 {
+  ObjectListDeclaration(Skydome);
 public:
   Skydome();
@@ -31,13 +32,13 @@
   void generateSkyPlane(int divisions, float planetRadius, float atmosphereRadius,
                         float hTile, float vTile);
-  
+
   void setShader(Shader* shader);
   void setTexture(GLuint texture);
-  
+
   void activate();
   void deactivate();
 
 private:
-  
+
   typedef struct VertexInfo
   {
@@ -48,5 +49,5 @@
 
   bool activateDome;
-  
+
   VertexInfo *planeVertices;
   int numPlaneVertices;
@@ -59,5 +60,5 @@
   VertexInfo *vertices;
   int numVertices;
-  
+
   GLuint texture;
   Shader* shader;
Index: trunk/src/world_entities/skysphere.cc
===================================================================
--- trunk/src/world_entities/skysphere.cc	(revision 9656)
+++ trunk/src/world_entities/skysphere.cc	(revision 9869)
@@ -27,5 +27,4 @@
 
 #include "skysphere.h"
-#include "stdincl.h"
 
 #include "material.h"
@@ -33,5 +32,5 @@
 
 
-
+ObjectListDefinition(Skysphere);
 
 /**
@@ -41,5 +40,5 @@
 Skysphere::Skysphere(char* fileName)
 {
-  this->setClassID(CL_SKYSPHERE, "SkySphere");
+  this->registerObject(this, Skysphere::_objectList);
   this->toList(OM_BACKGROUND);
   if (fileName == NULL)
Index: trunk/src/world_entities/skysphere.h
===================================================================
--- trunk/src/world_entities/skysphere.h	(revision 9656)
+++ trunk/src/world_entities/skysphere.h	(revision 9869)
@@ -24,4 +24,5 @@
 class Skysphere : public WorldEntity
 {
+  ObjectListDeclaration(Skysphere);
 
  public:
Index: trunk/src/world_entities/space_ships/collision_probe.cc
===================================================================
--- trunk/src/world_entities/space_ships/collision_probe.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/collision_probe.cc	(revision 9869)
@@ -24,7 +24,8 @@
 
 
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(CollisionProbe, CL_COLLISION_PROBE);
 
-
-CREATE_FACTORY(CollisionProbe, CL_COLLISION_PROBE);
+CREATE_FACTORY(CollisionProbe);
 
 
@@ -56,5 +57,5 @@
 void CollisionProbe::init()
 {
-  this->setClassID(CL_COLLISION_PROBE, "CollisionProbe");
+  this->registerObject(this, CollisionProbe::_objectList);
 
   bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
Index: trunk/src/world_entities/space_ships/collision_probe.h
===================================================================
--- trunk/src/world_entities/space_ships/collision_probe.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/collision_probe.h	(revision 9869)
@@ -13,4 +13,5 @@
 class CollisionProbe : public Playable
 {
+  ObjectListDeclaration(CollisionProbe);
 
   public:
Index: trunk/src/world_entities/space_ships/cruizer.cc
===================================================================
--- trunk/src/world_entities/space_ships/cruizer.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/cruizer.cc	(revision 9869)
@@ -29,10 +29,12 @@
 
 #include "graphics_engine.h"
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
 
-CREATE_FACTORY(Cruizer, CL_CRUIZER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Cruizer, CL_CRUIZER);
+CREATE_FACTORY(Cruizer);
 
 /**
@@ -89,5 +91,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_CRUIZER, "Cruizer");
+  this->registerObject(this, Cruizer::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D);
Index: trunk/src/world_entities/space_ships/cruizer.h
===================================================================
--- trunk/src/world_entities/space_ships/cruizer.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/cruizer.h	(revision 9869)
@@ -16,4 +16,5 @@
 class Cruizer : public Playable
 {
+  ObjectListDeclaration(Cruizer);
   public:
     Cruizer(const std::string& fileName);
Index: trunk/src/world_entities/space_ships/helicopter.cc
===================================================================
--- trunk/src/world_entities/space_ships/helicopter.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/helicopter.cc	(revision 9869)
@@ -25,5 +25,5 @@
 
 #include "util/loading/factory.h"
-#include "util/loading/resource_manager.h"
+#include "sound/resource_sound_buffer.h"
 
 #include "key_mapper.h"
@@ -34,16 +34,19 @@
 #include "debug.h"
 
-CREATE_FACTORY(Helicopter, CL_HELICOPTER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Helicopter, CL_HELICOPTER);
+CREATE_FACTORY(Helicopter);
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(Helicopter, CL_HELICOPTER,
-                        addMethod("moveUp", ExecutorLua1<Helicopter,bool>(&Helicopter::moveUp))
-                            ->addMethod("moveDown", ExecutorLua1<Helicopter,bool>(&Helicopter::moveDown))
-                            ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                            ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                            ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                            ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+CREATE_SCRIPTABLE_CLASS(Helicopter,
+			addMethod("moveUp", Executor1<Helicopter, lua_State*,bool>(&Helicopter::moveUp))
+			    ->addMethod("moveDown", Executor1<Helicopter, lua_State*,bool>(&Helicopter::moveDown))
+			    ->addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+			    ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+			    ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+			    ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
 
                        );
 
+
 /**
  *  creates the controlable Helicopter
@@ -60,7 +63,4 @@
 {
   this->setPlayer(NULL);
-
-  if (this->chopperBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->chopperBuffer);
 }
 
@@ -100,5 +100,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate("Cannon"));
 
   cannon->setName("BFG");
@@ -112,7 +112,5 @@
 
   //load sound
-  if (this->chopperBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->chopperBuffer);
-  this->chopperBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/engine/chopper.wav", WAV);
+  this->chopperBuffer = OrxSound::ResourceSoundBuffer("sound/engine/chopper.wav");
 
 }
@@ -124,7 +122,5 @@
 void Helicopter::init()
 {
-  this->chopperBuffer = NULL;
-
-  this->setClassID(CL_HELICOPTER, "Helicopter");
+  this->registerObject(this, Helicopter::_objectList);
   PRINTF(4)("HELICOPTER INIT\n");
 
Index: trunk/src/world_entities/space_ships/helicopter.h
===================================================================
--- trunk/src/world_entities/space_ships/helicopter.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/helicopter.h	(revision 9869)
@@ -17,4 +17,5 @@
 class Helicopter : public Playable
 {
+  ObjectListDeclaration(Helicopter);
 
   public:
@@ -79,5 +80,5 @@
 
     OrxSound::SoundSource  soundSource;
-    OrxSound::SoundBuffer* chopperBuffer;
+    OrxSound::SoundBuffer  chopperBuffer;
 
 };
